Reviving the Wikimedia Commons iOS App
Closed, DeclinedPublic

Description

Type of activity: Unconference session
Main topic:

The problem

iPhones are considered to possess very good cameras but the lack of an official (or officially endorsed) Wikimedia Commons app for iOS means that a large audience is alienated from making useful contributions to Wikimedia Commons.

Expected outcome

This session could explore the following:

  • Figure out if its possible to build an app again with the help of the community (I am personally very interested and qualified)
  • Figure out quality metrics that will make the app meaningful to users (eg. Number of people who have viewed my photo)
  • Plan a rough timeline & roadmap for the app
  • Launch a stable build and come up with a plan to keep future maintenance costs low (or galvanize enough motivation for long-term maintenance)

Current status of the discussion

Just proposed this

Links

Related Objects

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 5 2016, 7:40 PM
Qgil added subscribers: Commons-App-Android-Upload, Qgil.

Thank you for this proposal, @anirudh24seven. I was looking to which Summit main topic could be this submission be related, and I didn't find a clear candidate. Maybe if this proposal would be also submitted at the 2016 Community Wishlist Survey and would be one of the most voted... but that is a long shot to plan for today.

Would you be fine having this session proposed for the Unconference, for now? In any case, I do encourage you to submit this idea to https://meta.wikimedia.org/wiki/2016_Community_Wishlist_Survey when that process starts. It is surely an interesting idea.

Restricted Application added a subscriber: Poyekhali. · View Herald TranscriptOct 5 2016, 8:53 PM

@anirudh24seven, could you add a comment on Commons_talk:Mobile_app expressing your desire to revive the app?

This would be great. AFAIK there isn't even an 'unofficial' iOS app for this any more, last I checked it had been pulled from the store because the developer's account had expired (see here).

If there is anything that we (the Android app developers) can do to help with this, please do let us know.

@Qgil: Sure. We can have this session proposed for the Unconference. I'll definitely submit the idea when the process starts. Thanks!

@RobLa-WMF: Looking into it. Thanks.

@josephine_l: Yeah. I saw that link few weeks ago/ I've also been following your work on the Commons Android app. Thanks. :)

Qgil added a comment.Oct 7 2016, 7:47 AM

The sensible timeline for this proposal would be:

  1. Check before the Summit whether there is enough interest on this idea among Summit participants.
  2. If there is enough interest, then organize the session around how to proceed.

Just some thoughts:

The iOS Commons app disappeared from the store because the maintainer could not afford the 99$/per year Apple levy. Knowing the app was about to leave the store, he probably had less motivation to maintain it.

If the WMF lets an hypothetical new (or same) iOS Commons app maintainer use the existing iOS account of the WMF, that cost could be avoided. The app would need to go though the same process as the Android app did, obviously.

Alternatively, finding a reasonably trustable person who owns an Apple developer (and already pays the Apple fees every year for reasons independent from Wikimedia, for instance having other apps) could be an easy way to start.

Qgil added a comment.Oct 7 2016, 11:19 AM

Just some thoughts:

The iOS Commons app disappeared from the store because the maintainer could not afford the 99$/per year Apple levy.

A simple way to cover this cost would be to request a Rapid Grant. Maybe more sophisticated and cost-efficient ways could be found, but a Rapid Grant could a short term solution that would provide one year of margin to investigate other possible solutions.

JMinor added a subscriber: JMinor.Oct 27 2016, 8:02 PM

If the only barrier is the Apple account, as the current PM of the Wikipedia app I'd be happy to work out some way for this to be released under the official WMF account (and remove the cost issue). As with the Android app, we'd just want to make sure that there is a plan in place to actually deliver updates and potentially respond to bugs and user requests.

The dev summit seems like a good venue to discuss how to best revive this.

cmadeo added a subscriber: cmadeo.Oct 27 2016, 11:23 PM

@JMinor : Wonderful!

I suggest you create a new issue at https://github.com/lyrk/Commons detailing your offer.

I guess the second barrier will be to find open source enthusiasts who develop for the proprietary iOS. As is understandable, most open source developers prefer Android.

As the next step, I would like everyone's opinion on the following questions:

  1. Do we take one of the existing apps and build on top of it? My concern is that the technical debt might affect us if the previous owner is not available for help.
  1. If we are starting anew, my opinion is to follow feature-parity and roadmap of the Android Commons app. Does this make sense? Also, I need the opinion of the iOS team on adopting Objective-C vs Swift 2 vs Swift 3 if we're taking this approach.
  1. I would personally like to build a proof-of-concept or at least start building the app so that we have something more substantial to discuss during the dev summit. I am an Android & iOS dev and I can use the Android Commons app for reference, as stated in the previous point. I can start documenting my approach too. Any suggestions?

My offer was to help someone specific like @anirudh24seven advance this proposal, and unblock "apple charges $100/year to put apps on the store" as a blocking concern. It is not in my power to make offers of foundation resources on GitHub forks.

@anirudh24seven let me tag @Fjalapeno and @Mhurd from the iOS team who can better answer your technical questions. My take on them:

  1. I believe @Mhurd was involved in the initial development, so he may be best positioned to asses the amount of tech debt.
  2. Feature parity with Android sounds reasonable to me. Right now most of the Wikipedia app is Obj-C but we continue to add Swift code. Switching to Swift would mean re-write of the app, so its also a question of what you are comfortable with.
  3. One first step might be to take the abandoned code, and see if you can build it for iOS 9/10 and update the project for the current XCode. If that goes smoothly, that might be a vote to just update the existing app. If that results in a bunch of difficult-to-fix updates, that might be reason to start from "scratch".

Feature parity with the Android Commons app makes a lot of sense to me. I don't have much iOS experience, but my opinion is that using Swift might make it easier to recruit and on-board new volunteers, compared to a legacy app that is running Objective-C.

cscott added a subscriber: cscott.Nov 3 2016, 9:22 PM

As I understand it, once of the reasons why the Commons uploaders were deprecated was because we didn't have adequate review mechanisms to cope with the flood of uploaded images. As such, this might be relevant to the https://www.mediawiki.org/wiki/Wikimedia_Developer_Summit/2017/A_unified_vision_for_editorial_collaboration topic, in terms of discussing review mechanisms at least.

Nicolas_Raoul added a comment.EditedNov 4 2016, 3:20 AM

@cscott :

[...] reasons why the Commons uploaders were [...]

Do you have any reference for this statement?
If yes, I would be very glad to see it, as nobody seems to be able to find one :-)
In particular in order to check by myself whether it was about the iOS/Android Commons apps too, or only about the Wikipedia's integrated upload feature.

By the way, we (the Android Commons app team) have started our own efforts to improve contributions quality:

Cheers!

RHo added a subscriber: RHo.Nov 15 2016, 5:33 PM
srishakatux added a subscriber: srishakatux.EditedDec 16 2016, 6:53 AM

as we are working on a plan to incorporate the ‘unconference sessions’ that have been proposed so far and would be generated on the spot, wondering if we have a session owner for this unconference proposal yet? cc @anirudh24seven

To maintain the consistency, please consider referring to the template of the following task description: https://phabricator.wikimedia.org/T149564.

@anirudh24seven: Did this session take place?
If yes, are there any notes or action items to share? Are there any actionable items (tasks to create / link?) from this session?
If not, could you close this task as declined? Thanks in advance!

anirudh24seven closed this task as Declined.Jan 31 2017, 1:04 AM

It did not take place.